//+------------------------------------------------------------------
//| %r 2 MA's Cross
//| Indicator modification from Wpr_ma cross mtf+ level alerts 
//| to show %R 2 ma's crossings and alert on the crossing
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3 //
#property indicator_color1  CLR_NONE
#property indicator_color2  Green
#property indicator_color3  Red //
#property indicator_width2  2
#property indicator_width3  2
#property indicator_style2  STYLE_SOLID
//#property indicator_minimum 0
//#property indicator_maximum 200

// 0 -> sma (simple moving average)
// 1 -> ema (exponential moving average)
// 2 -> smma (smoothed moving average - Wilders ema)
// 3 -> as you already know lwma (linear weighted moving average) 
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    WprPeriod       = 14; //| Momentum Period
extern int    MaPeriod        = 2;  //| Fisrt MA Period
extern int    MbPeriod        = 8;  //| Second MA Period
extern int    MaMode          = MODE_SMMA; //| First MA Mode
extern int    MbMode          = MODE_SMA;  //| Second MA Mode


//double levelOb         = -20;
//double levelOs         = -80;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern string soundFile       = "alert2.wav";

extern bool   ShowArrows      = true;
extern string arrowsIdentifier= "wpr Arrows1";
extern color  arrowsUpColor   = LimeGreen;
extern color  arrowsDnColor   = Red;

//
//
//
//
//

double wpr[];
double wprma[];
double wprmb[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
    IndicatorBuffers(4);
    SetIndexBuffer(0,wpr);
    SetIndexBuffer(1,wprma);
    SetIndexBuffer(2,wprmb);//
    SetIndexBuffer(3,trend);
//    SetLevelValue(0,levelOs);
//    SetLevelValue(1,levelOb);
    
    //
    //
    //
    //
    //
   
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame == "returnBars");     if (returnBars)     return(0);
      calculateValue    = (TimeFrame == "calculateValue"); if (calculateValue) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);   

   //
   //
   //
   //
   //
    
   IndicatorShortName("Momentum  (" +WprPeriod+ ", " +MaPeriod+ ", " +MbPeriod+ ")");
 return(0);
}

int deinit() 
{ 
   if (!calculateValue && ShowArrows) deleteArrows();
   
return(0); 
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { wpr[0] = limit+1; return(0); }


  
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for(int i=limit; i>=0; i--)
      {
         
       //      double hi = High[iHighest(NULL,0, MODE_HIGH,WprPeriod,i)];
      //   double lo =  Low[iLowest(NULL, 0, MODE_LOW, WprPeriod,i)];
      //   if (hi!=lo)      
      //        wpr[i]=iMomentum(NULL,0,WprPeriod,PRICE_CLOSE,0);
      //   else wpr[i] = 0; 
             
      wpr[i]=iMomentum(NULL,0,WprPeriod,PRICE_CLOSE,0);
              
        
     
         
         //
         //
         //
         //
         //
         
         trend[i] = 0;
         
         if (wprma[i]>wprmb[i]) trend[i] = 1;             
         if (wprma[i]<wprmb[i]) trend[i] = -1;
           
          // manageArrow(i);    
      }
      for (i = limit; i >= 0 ; i--)  
                                    { wprma[i] = iMAOnArray(wpr,0,MaPeriod,0,MaMode,i);
                                      wprmb[i] = iMAOnArray(wpr,0,MbPeriod,0,MbMode,i);       
     // manageAlerts();
     }
    return(0);
    }
    
    //
    //
    //
    //
    //       
    
    limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    for(i=limit; i>=0; i--)
    {
       int y = iBarShift(NULL,timeFrame,Time[i]);        
          wpr[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,MaPeriod,MbPeriod,MaMode,MbMode,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpColor,arrowsDnColor,0,y);
          wprma[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,MaPeriod,MbPeriod,MaMode,MbMode,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpColor,arrowsDnColor,1,y);
          wprmb[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,MaPeriod,MbPeriod,MaMode,MbMode,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpColor,arrowsDnColor,2,y);
    }    
return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar+1] ==  1 && trend[whichBar] != 1) doAlert(whichBar,"sell");
         if (trend[whichBar+1] == -1 && trend[whichBar] !=-1) doAlert(whichBar,"buy");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(Period())+" rsx ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," rsx "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (ShowArrows)
   {
      deleteArrow(Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i+1] ==  1 && trend[i] != 1) drawArrow(i,arrowsDnColor,226,true);
         if (trend[i+1] == -1 && trend[i] !=-1) drawArrow(i,arrowsUpColor,225,false);
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = 3.0*iATR(NULL,0,20,i)/4.0;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         
         
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+ gap);
                                         
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] - gap);
        
         
         
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

